Subject: bug#77039: 31.0.50; Flickering on macOS

From: Aaron Jensen <[email-masked]>
Date: Sun, 16 Mar 2025 17:44:16 +0000

Aaron

On Sun, Mar 16, 2025 at 10:19 AM, Aaron Jensen <[email-masked]>
wrote:

> On Sun, Mar 16, 2025 at 10:15 AM, Aaron Jensen <[email-masked]>
> wrote:
>
>> Hi,
>>
>> I've narrowed it down to the addition to frame in the glyph comparison.
>> As far as I can tell, the attached patch removes the flickering for me. I
>> saw the cursor blink once, but I couldn't reproduce that and I couldn't get
>> it to do it again.
>>
>> The patch is not suitable for applying to master as it certainly breaks
>> something int he tty child frame code, but hopefully it gives you an idea
>> of what the problem might be. I'm going to experiment with accounting for
>> the NULL frame in the space glyph and see if that helps.
>>
>> Aaron
>>
>
> Actually, while I don't fully understand the code, it seems suspect to me
> that there is a global `space_glyph` glyph struct that gets initialized
> with a NULL frame but the frame is mutated over time. I wonder if my not
> removing the frame check inside of CHAR_GLYPH_SPACE_P is why I saw the
> cursor flicker once.
>

I was mistaken here, I believe. It's not mutated over time — I'm just rusty
on C and I misread some code.

Aaron

>
>> On Sun, Mar 16, 2025 at 2:00 AM, Gerd Möllmann <[email-masked]>
>> wrote:
>>
>>> Aaron Jensen <[email-masked]> writes:
>>>
>>> One other thing, it may be related to tab-bar mode. It seems to be
>>> connected to when I switch tabs — one tab has a vterm buffer scrolling
>>> output and the other just has a grep output, for example. If I don't get
>>> the flicker in the grep output, I can switch back and forth between the two
>>> tabs a couple times and I'll start to get it.
>>>
>>> Doesn't ring a bell, I'm afraid. Tab bar, AFAIU it, is "just playing
>>> with window configurations". Why that would lead to flickering, I can't
>>> imagine ATM.
>>>
>>